package edu.nyu.scps.pearl;

import android.graphics.PointF;


public class Pearl {
    private static final float elasticity = 0.2f; //higher number means more resistant to stretching
    private static final float gravity = 3.0f;
    private static final float mass = 2.0f;	      //must be non-negative
    private static final float friction = 0.7f;   //must be non-negative

    private PointF center = new PointF();
    private PointF velocity = new PointF(); //born with zero velocity

    public void dragTowards(PointF p) {
        final PointF force = new PointF(
                (p.x - center.x) * elasticity,
                (p.y - center.y) * elasticity + gravity * mass
        );

        //F = ma
        //Therefore a = F/m

        final PointF acceleration = new PointF(
                force.x / mass,
                force.y / mass
        );

        velocity.set(
                friction * (velocity.x + acceleration.x),
                friction * (velocity.y + acceleration.y)
        );

        center.set(
                center.x + velocity.x,
                center.y + velocity.y
        );
    }

    //A setter and a getter.

    public void setCenter(PointF center) {
        this.center.set(center.x, center.y);
    }

    public PointF getCenter() {
        return center;
    }

}
